{% extends 'Soutenances/base.html' %}
{% load static %}
<link rel="stylesheet" href="{% static 'Soutenances/css/style.css' %}">

{% block title %} Détail de l'Evenement "{{ object.nom }}" {% endblock %}

{% block contenu %}

{% if user.groupe == "admin" or user.groupe == "professeurs" or user.classe == object.groupe.nom and user.groupe == "eleves" %}
<input id="dd" value= {{ object.date_debut }} style="display:none;"/>
<input id="df" value= {{ object.date_fin }} style="display:none;"/>
<input id="dureeS" value= {{ object.dureeSoutenances }} style="display:none;"/>
<input id="idEven" value= {{ object.id }} style="display:none;"/>

<section id="evenementDetail">
    <section id="infoEvent">
        <h3>Informations Evenement</h3>
        <ul class="list-group">
            <li class="list-group-item center">Du {{ object.date_debut }} au {{ object.date_fin }}</li>
            <li class="list-group-item">Enseignant : {{ object.enseignant }}</li>
            <li class="list-group-item">Durée des soutenances : {{ object.dureeSoutenances }}min</li>
            
        </ul>
    </section>
    <button class="btn btn-primary" id="attribuer">Attribuer groupes</button>
    <ul class="list-group" id="ulGRoupe">
        
    </ul>
</section>

<script>
    function getCookie(name) {
          var cookieValue = null;
          if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
          for (var i = 0; i < cookies.length; i++) {
               var cookie = jQuery.trim(cookies[i]);
          // Does this cookie string begin with the name we want?
          if (cookie.substring(0, name.length + 1) == (name + '=')) {
            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
              break;
             }
          }
      }
 return cookieValue;
}

$(document).ready(function () {
    
    $( "#attribuer" ).click(function() {
        let dureeS = document.getElementById('dureeS').value;
        let idEven = document.getElementById('idEven').value;
        let dd = document.getElementById('dd').value;
        let df = document.getElementById('df').value;
        $.ajax({
            url: '/soutenances/api/groupesSoutenances/',
            type: 'GET',
            dataType: 'json',
            success: function (data, textStatus, xhr) {
                $.each( data, function( key,val ) { 

                    
                    
                    if (val.evenement == idEven){

                        let li = document.createElement("li");
                        li.id= "li" + val.id;
                        li.className = "list-group-item";
                        let selectGroupe = document.createElement("select");
                        selectGroupe.id = "selectGroupe" + val.id;
                        let selectDate = document.createElement("select");
                        selectDate.id ="selectDate" + val.id;
                        let p = document.createElement("p");
                        p.id ="p" + val.id;

                        let listeJours = ["lundi","mardi","mercredi","jeudi","vendredi"];
                        let i = listeJours.indexOf(dd);
                        let ifin = listeJours.indexOf(df);
    
                        let listeJoursSelect = [];
                        listeJoursSelect.push(listeJours[i]);
                        while (i != ifin) {
                            i ++
                            listeJoursSelect.push(listeJours[i]);
                        }



                        for (jour of listeJoursSelect){
                            let optionJour = document.createElement("option");
                            optionJour.id = "jour" + listeJours.indexOf(jour);
                            optionJour.text = jour;
                            selectDate.appendChild(optionJour);
                        }

                        let selectSAlles= document.createElement("select")
                        let listeSalles = ["i21","i22","i23","i24","i25"];
                        selectSAlles.id = "selectSAlles" + val.id;
                        for (salles of listeSalles){
                            let optionSalles = document.createElement("option");
                            optionSalles.id = "salle" + listeSalles.indexOf(salles);
                            optionSalles.text = salles;
                            selectSAlles.appendChild(optionSalles);
                        }
                        let inputHeureDebut = document.createElement("input");
                        inputHeureDebut.id = "input" + val.id;
                        inputHeureDebut.value="";
                        inputHeureDebut.placeholder="Heure de début (ex: 08h20)";

                        let buttonValid = document.createElement("button");
                        buttonValid.id = "button"+val.id ;
                        buttonValid.innerHTML = "Ajouter Slot";

                       
                        
                        $.ajax({
                            url: '/soutenances/api/groupesSoutenances/',
                            type: 'GET',
                            dataType: 'json',
                            success: function (data1, textStatus1, xhr1) {
                                $.each( data1, function( key1,val1 ) { //KEY salle, VAl : jour 
                                    if (val1.evenement==idEven){
                                        let option = document.createElement("option");
                                        option.value=val1.id;
                                        option.text = val1.nom;
                                        selectGroupe.appendChild(option);

                                    }
                                });
                            },
                            error: function (xhr, textStatus, errorThrown) {
                                console.log('Error in Operation');
                            }
                        });
                        
                        li.appendChild(selectGroupe);
                        li.appendChild(selectDate);
                        li.appendChild(selectSAlles);
                        li.appendChild(inputHeureDebut);
                        li.appendChild(buttonValid);
                        li.appendChild(p);
                        document.getElementById('ulGRoupe').appendChild(li);

                        $("#button"+val.id).click(function() {
                            let resSelectGroupe = $( "#selectGroupe"+val.id ).val();
                            let resselectDate = $( "#selectDate"+val.id ).val();
                            let resselectSAlles = $( "#selectSAlles"+val.id ).val();
                            let resinputHeureDebut = $( "#input"+val.id ).val();

                            if (resinputHeureDebut != null && resinputHeureDebut !=""){
                                let regex = /^[0-9]{2}h[0-9]{2}$/;
                                if(!regex.test(resinputHeureDebut))
                                {
                                    document.getElementById("p"+val.id).innerHTML = "Format heure début non valide ( 08h20 )";
                                }
                                else
                                {
                                    
                                    let listeHeureDebut = resinputHeureDebut.split("h");// "8h25"

                                    // let duree = dureeS / 60; // 25 --> 0.33

                                    dureeS = parseInt(dureeS);
                                    
                                    let min = parseInt(listeHeureDebut[1]) + dureeS; //25 /60
                                    let hour = parseInt(listeHeureDebut[0]); // 8 

                                    console.log(min);
                                    if (min >= 60 ){
                                        hour = hour +1;
                                        min = min - 60;
                                    }

                                    // hour = hour + "";
                                    // min = min + "";

                                    
                                    if (hour < 10 ){
                                        hour = "0" + hour;
                                    }

                                    if (min < 10){
                                        min = "0" + min;
                                    }

                                    let heureFin = hour + "h"+ min;
                                    
                                    

                                    $.ajax({
                                        url: '/soutenances/api/slots/',
                                        type: 'GET',
                                        dataType: 'json',
                                        success: function (data1, textStatus, xhr) {
                                            let a = true;
                                            $.each( data1, function( key2,val2 ) {
                                                if ((val2.salle== resselectSAlles)){
                                                    
                                                    
                                                    if ((val2.date== resselectDate)){
                                                       

                                                        if ((resinputHeureDebut >= val2.heure_debut && resinputHeureDebut < val2.heure_fin ) || (heureFin > val2.heure_debut && heureFin <= val2.heure_fin )){
                                                            a =  false;
                                                        } 
                                                        
                                                    }
                                                }
                                            });
                                            if (a){
                                                var csrftoken = getCookie('csrftoken');
                                    let idEvent = $( "#idEven").val();
                                    $.ajax({
                                        url: '/soutenances/api/slots/',
                                        type: 'POST',
                                        dataType: 'json',
                                        data: { csrfmiddlewaretoken : csrftoken,
                                        date: resselectDate,
                                        heure_debut: resinputHeureDebut,
                                        heure_fin: heureFin,
                                        salle: resselectSAlles,
                                        evenement: idEvent
                                        },
                                        success: function (data, textStatus, xhr) {
                                            

                                            $.ajax({
                                                url: '/soutenances/api/Soutenances/',
                                                type: 'POST',
                                                dataType: 'json',
                                                data: { csrfmiddlewaretoken : csrftoken,
                                                slot: data.id,
                                                groupeSoutenance: resSelectGroupe,
                                                },
                                                success: function (data, textStatus, xhr) {
                                                    document.getElementById("p"+val.id).innerHTML = "Soutenance ajoutée !";

                                                },
                                                error: function (xhr, textStatus, errorThrown) {
                                                    console.log('Error in Operation');
                                                }
                                            });
                                            
                                            
                                        },
                                        error: function (xhr, textStatus, errorThrown) {
                                            console.log('Error in Operation');
                                        }
                                    });
                                            }
                                            else{
                                                document.getElementById("p"+val.id).innerHTML = "Ajout impossible, slot déjà occupé";
                                            }
                                            
                            
                                        },
                                        error: function (xhr, textStatus, errorThrown) {
                                            console.log('Error in Operation');
                                        }
                                    });
                                    
                                }
                                }
                            });
                    }
                });
                
                
            },
            error: function (xhr, textStatus, errorThrown) {
                console.log('Error in Operation');
            }
        });


    });
        
       
});
</script>

{% else %}
<div class="alert alert-danger" role="alert">
  Vous <strong>n'avez pas accès</strong> à cette page !
</div>
{% endif %}
{% endblock %}
